//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "base.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender) /*I*/
{
 ::ChangeClipboardChain(Handle,hNextWnd);

 NOTIFYICONDATA icon;

 icon.cbSize = sizeof(NOTIFYICONDATA);
 icon.hWnd = Handle;
 icon.uID = 128;
 icon.uFlags = NULL;
 Shell_NotifyIcon(NIM_DELETE, &icon);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)  /**/
{
 if (!InitWinSock()) { Beep(); exit(-1); }

 char * tmpdir;
 tmpdir = _getdcwd(0, NULL, MAXBUFFER);
 if (!tmpdir) {
    Beep();
    MessageDlg("mۂł܂", mtError, TMsgDlgButtons() << mbOK, 0);
    exit(-1);
 }
 AnsiString Ansitmpdir(tmpdir);
 delete [] tmpdir;
 tmpfilename = Ansitmpdir;
 if (*(tmpfilename.AnsiLastChar()) != '\\')
    tmpfilename.Insert("\\", tmpfilename.Length() + 1);
 tmpfilename += "tmpfile";

 icon.cbSize = sizeof(NOTIFYICONDATA);  //^XNgCւ̃ACRo^
 icon.hWnd = Handle;
 icon.uID = 128;
 icon.uFlags = (NIF_MESSAGE | NIF_ICON | NIF_TIP);
 icon.uCallbackMessage = WM_USER;
 icon.hIcon = Application->Icon->Handle;
 lstrcpy(icon.szTip, "PopupViewer");
 Shell_NotifyIcon(NIM_ADD, &icon);
 icon.uFlags = NIF_ICON;

 Initialize = false;
 IconModify = false;
 maxitem = 0;
 DownNum = 0;
 IconCount = 0;
 MaxX = GetSystemMetrics(SM_CXMAXIMIZED);
 MaxY = GetSystemMetrics(SM_CYMAXIMIZED);
 for (int i = 0; i < 10; i++) PicCount[i] = 0;

 URLInfo tmpURL("");

 hNextWnd = SetClipboardViewer(Handle);
}
//---------------------------------------------------------------------------

void  __fastcall TForm1::ClipURL()   //Nbv{[h̕񂪉摜t@C
{                                    //̃N_E[hJn
 if (Initialize) {
    if (Clipboard()->HasFormat(CF_TEXT)) {
       AnsiString tmp = Clipboard()->AsText;
       URLInfo URL(tmp);       
       if (URL.GetServer() != NULL && (URL.GetExtensions() == "bmp"
           || URL.GetExtensions() == "jpg" || URL.GetExtensions() == "jpeg"
            || URL.GetExtensions() == "png" || URL.GetExtensions() == "gif")) {
          SetIcon();                  //Ή摜`ύXŏ镔
          DownParam *D_P;
          try {
              D_P = new DownParam(URL, DownNum, this);
              DWORD dw;
              HANDLE ThreadHandle;
              ThreadHandle = CreateThread(NULL, 0, Download,
                                (LPVOID) D_P, 0, &dw);
              if (ThreadHandle) {
                 map_threadhandle.insert(make_pair(DownNum, ThreadHandle));
                 if (DownNum == INT_MAX) DownNum = 0;
                 else DownNum++;
                 return;
              } else delete D_P;
          }
          catch (std::bad_alloc) {}
          if (DownNum == INT_MAX) DownNum = 0;
          else DownNum++;
          ResetIcon();
          Beep();
          AnsiString *tmpmessage;
          try { tmpmessage = new AnsiString; } 
          catch (std::bad_alloc) {
             Beep();
             MessageDlg("bZ[Wpmۂł܂", mtError, TMsgDlgButtons() << mbOK, 0);
             return;
          }
          *tmpmessage = "Xbh쐬s";
          SendMessageA(Handle, MESSAGE_LOG, (int) tmpmessage, NULL);
       }
    }
 } else Initialize = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{                                            /*摜̃_E[hJn*/
 URLInfo URL(URLBOX->Text);

 AnsiString *tmpmessage;
 try { tmpmessage = new AnsiString; }
 catch (std::bad_alloc) {
    Beep();
    MessageDlg("bZ[Wpmۂł܂", mtError, TMsgDlgButtons() << mbOK, 0);
    return;
 }

 if (URL.GetServer() == NULL) {
    Beep();
    *tmpmessage = "URLs";
    SendMessageA(Handle, MESSAGE_LOG, (int) tmpmessage, NULL);
    return;
 }

 if (URL.GetExtensions() != "bmp" && URL.GetExtensions() != "jpg"
     && URL.GetExtensions() != "jpeg" && URL.GetExtensions() != "png"
      && URL.GetExtensions() != "gif") {
    Beep();                               //Ή摜`ύXŏ镔
    *tmpmessage = "ΉĂȂgq";
    SendMessageA(Handle, MESSAGE_LOG, (int) tmpmessage, NULL);
    return;
 }


 SetIcon();
 DownParam *D_P;
 try {
     D_P = new DownParam(URL, DownNum, this);
     DWORD dw;
     HANDLE ThreadHandle;
     ThreadHandle = CreateThread(NULL, 0, Download, (LPVOID) D_P, 0, &dw);
     if (ThreadHandle) {
        map_threadhandle.insert(make_pair(DownNum, ThreadHandle));
        if (DownNum == INT_MAX) DownNum = 0;
        else DownNum++;
        delete tmpmessage;
        return;
     } else delete D_P;
 }
 catch (std::bad_alloc) {}
 if (DownNum == INT_MAX) DownNum = 0;
 else DownNum++;
 ResetIcon();
 Beep();
 *tmpmessage = "Xbh쐬s";
 SendMessageA(Handle, MESSAGE_LOG, (int) tmpmessage, NULL);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Exit1Click(TObject *Sender)
{
 if (!map_threadhandle.size()) Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Main1Click(TObject *Sender)
{
 Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetIcon()
{                                          //ACRύX
 if (!IconModify) {
    icon.hIcon = LoadIcon(NULL, IDI_EXCLAMATION);
    Shell_NotifyIcon(NIM_MODIFY, &icon);
    IconModify = true;
 }
 IconCount++;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ResetIcon()
{                                          //ACRύX
 if (!(--IconCount)) {
    icon.hIcon = Application->Icon->Handle;
    Shell_NotifyIcon(NIM_MODIFY, &icon);
    IconModify = false;
 }
 if (IconCount < 0) IconCount = 0;
}
//---------------------------------------------------------------------------

DWORD WINAPI Download(LPVOID lpParam)
{                                          //_E[hJn
 fstream file_s;
 SOCKET sock;
 AnsiString tmpstr = ((DownParam *) lpParam)->TF->tmpfilename + ((DownParam *) lpParam)->D_Num,
            *tmpmessage;

 try { tmpmessage = new AnsiString; }
 catch (std::bad_alloc) {
    Beep();
    MessageDlg("bZ[Wpmۂł܂", mtError, TMsgDlgButtons() << mbOK, 0);
    SendMessageA(((DownParam *) lpParam)->TF->Handle, DOWN_ERROR, ((DownParam *) lpParam)->D_Num, NULL);
    delete ((DownParam *) lpParam);
    return -1;
 }

 try {
     struct in_addr ServerIP = IPget(((DownParam *) lpParam)->URL.GetServer());
     if (ServerIP.s_addr == NULL) throw IPERROR;

     file_s.open(tmpstr.c_str(), ios::binary | ios::out | ios::trunc);
     if (!file_s.is_open()) throw FILEOPENERROR;

     sock = socket(AF_INET, SOCK_STREAM, 0);
     if (sock == INVALID_SOCKET) throw SOCKERROR;

     struct sockaddr_in severaddr;
     severaddr = Initsockaddr_in(((DownParam *) lpParam)->URL.GetPort(), ServerIP);

     if (connect(sock, (SOCKADDR *) &severaddr, sizeof(severaddr)) == SOCKET_ERROR)
        throw CONNECTERROR;

     AnsiString RequestMess;
     RequestMess = ((DownParam *) lpParam)->URL.CreateGETRequest();
     if (send(sock, RequestMess.c_str(), strlen(RequestMess.c_str()), 0) == SOCKET_ERROR)
        throw SENDERROR;

     *tmpmessage = ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":T[oɐڑ";
     SendMessageA(((DownParam *) lpParam)->TF->Handle, MESSAGE_LOG, (int) tmpmessage, 1);

     char buff[MAXBUFFER], *tmpbuf;
     int  delsize, recvsize, ret_select;
     struct timeval waittime;
     struct fd_set r_fd;

     FD_ZERO(&r_fd);
     FD_SET(sock, &r_fd);
     waittime.tv_sec = TIMEOUT;
     waittime.tv_usec = 0;

     ret_select = select(FD_SETSIZE, &r_fd, (fd_set *) 0, (fd_set *) 0,
                           &waittime);
     if (ret_select == SOCKET_ERROR || ret_select == FALSE) throw RECVERROR;
     if (!ret_select) throw TIMEOUTSOCK;

     recvsize = recv(sock, buff, sizeof(buff), 0);
     if (recvsize == SOCKET_ERROR) throw RECVERROR;

     delsize = DelHTTPHeader(buff);
     tmpbuf = new char [(recvsize - delsize)];

     for (int i = 0; i < (recvsize - delsize); i++) tmpbuf[i] = buff[i + delsize];
     file_s.write(tmpbuf, (recvsize - delsize));
     delete [] tmpbuf;

     while (1) {
           ret_select = select(FD_SETSIZE, &r_fd, (fd_set *) 0, (fd_set *) 0,
                                 &waittime);
           if (ret_select == SOCKET_ERROR || ret_select == FALSE) throw RECVERROR;
           if (!ret_select) throw TIMEOUTSOCK;
           recvsize = recv(sock, buff, sizeof(buff), 0);
           if (recvsize == SOCKET_ERROR) throw RECVERROR;
           else if (recvsize == 0) break;
           file_s.write(buff, recvsize);
     }
     file_s.close();
     shutdown(sock, SD_BOTH);
     closesocket(sock);
     Beep();
     *tmpmessage = ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":T[o̎M";
     SendMessageA(((DownParam *) lpParam)->TF->Handle, MESSAGE_LOG, (int) tmpmessage, NULL);
     SendMessageA(((DownParam *) lpParam)->TF->Handle, IB_CREATE,
                  (unsigned) lpParam, ((DownParam *) lpParam)->D_Num);
     return 0;
 }
 catch (int error) {
       switch (error) {
              case IPERROR:
                   *tmpmessage = "IP擾s";
                   break;
              case FILEOPENERROR:
                   *tmpmessage =
                      ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":ꎞt@C̍쐬s";
                   break;
              case SOCKERROR:
                   *tmpmessage =
                      ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":Socket̍쐬s";
                   file_s.close();
                   if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
                   break;
              case CONNECTERROR:
                   *tmpmessage =
                      ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":T[oւ̐ڑs";
                   file_s.close();
                   if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
                   closesocket(sock);
                   break;
              case SENDERROR:
                   *tmpmessage =
                      ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":T[oւ̑Ms";
                   file_s.close();
                   if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
                   shutdown(sock, SD_BOTH);
                   closesocket(sock);
                   break;
              case RECVERROR:
                   *tmpmessage =
                      ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":T[o̎Ms";
                   file_s.close();
                   if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
                   shutdown(sock, SD_BOTH);
                   closesocket(sock);
                   break;
              case TIMEOUTSOCK:
                   *tmpmessage =
                      ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":M^CAEg";
                   file_s.close();
                   if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
                   shutdown(sock, SD_BOTH);
                   closesocket(sock);
                   break;
      }
 }
 catch (std::bad_alloc) {
    *tmpmessage =
       ((DownParam *) lpParam)->URL.GetAnsiFilename() + ":̊蓖Ďs";
    file_s.close();
    if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
    shutdown(sock, SD_BOTH);
    closesocket(sock);
 }

 Beep();
 ((DownParam *) lpParam)->TF->ResetIcon();
 SendMessageA(((DownParam *) lpParam)->TF->Handle, MESSAGE_LOG, (int) tmpmessage, NULL);
 SendMessageA(((DownParam *) lpParam)->TF->Handle, DOWN_ERROR, ((DownParam *) lpParam)->D_Num, NULL);
 delete ((DownParam *) lpParam);
 return -1;
}
//---------------------------------------------------------------------------




