//---------------------------------------------------------------------------
#ifndef baseH
#define baseH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
#include <windows.h>
#pragma comment(lib, "ws2_32.lib")
#include "image.h"
#include "MyWinAPI.h"
#include "MyWinSock.h"
#include "URLInfo.h"
#include <direct.h>
#include <Clipbrd.hpp>
#include <winsock2.h>
#include <fstream.h>
#include <jpeg.hpp>
#include <map.h>

#pragma link "GLDPNG.obj" //Ή摜`ύXŏ镔
#include <GLDPNG.hpp>
#pragma link "gifimage.obj"
#include <gifimage.hpp>

#define MAXBUFFER 4096
#define SCROLLBARSIZE 18
#define TIMEOUT 60

#define IPERROR 1
#define SOCKERROR 2
#define SOCKEVERROR 3
#define CONNECTERROR 4
#define FILEOPENERROR 5
#define SENDERROR 6
#define RECVERROR 7
#define TIMEOUTSOCK 8

#define TRAY_MENU WM_USER
#define IB_CLOSE WM_USER + 101
#define IB_CREATE WM_USER + 103
#define DOWN_ERROR WM_USER + 104
#define MESSAGE_LOG WM_USER + 105

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// IDE Ǘ̃R|[lg
        TEdit *URLBOX;
        TListBox *STATUSBOX;
        TButton *Button1;
        TPopupMenu *PopupMenu1;
        TMenuItem *Main1;
        TMenuItem *N1;
        TMenuItem *Exit1;
        void __fastcall FormDestroy(TObject *Sender);
        void __fastcall FormCreate(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall Main1Click(TObject *Sender);
private:	// [U[錾
        HWND hNextWnd;
        bool Initialize, IconModify;
        NOTIFYICONDATA icon;
        AnsiString tmpfilename;
        int maxitem, MaxX, MaxY, PicCount[10], DownNum, IconCount;
        map<int, TImagebord*> map_imagebord;
        map<int, HANDLE> map_threadhandle;
        void __fastcall TRAYMENU(TMessage &Message);
        void __fastcall IBCLOSE(TMessage &Message);
        void __fastcall IBCREATE(TMessage &Message);
        void __fastcall DOWNERROR(TMessage &Message);
        void __fastcall MESSAGELOG(TMessage &Message);
        void __fastcall WMCHANGECBCHAIN(TMessage &Message);
        void __fastcall WMDRAWCLIPBOARD(TMessage &Message);
        void __fastcall WMCLOSE(TMessage &Message);
        void __fastcall ClipURL();
        void __fastcall SetIcon();
        void __fastcall ResetIcon();
        friend DWORD WINAPI Download(LPVOID lpParam);
public:		// [U[錾
        __fastcall TForm1(TComponent* Owner);
protected:

BEGIN_MESSAGE_MAP
  MESSAGE_HANDLER(WM_CHANGECBCHAIN, TMessage, WMCHANGECBCHAIN)
  MESSAGE_HANDLER(WM_DRAWCLIPBOARD, TMessage, WMDRAWCLIPBOARD)
  MESSAGE_HANDLER(WM_CLOSE, TMessage, WMCLOSE)
  MESSAGE_HANDLER(TRAY_MENU, TMessage, TRAYMENU)
  MESSAGE_HANDLER(IB_CLOSE, TMessage, IBCLOSE)
  MESSAGE_HANDLER(IB_CREATE, TMessage, IBCREATE)
  MESSAGE_HANDLER(DOWN_ERROR, TMessage, DOWNERROR)
  MESSAGE_HANDLER(MESSAGE_LOG, TMessage, MESSAGELOG)
END_MESSAGE_MAP(TForm)

};
//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;

//---------------------------------------------------------------------------
class DownParam {
public:
 URLInfo URL;
 int D_Num;
 TForm1 *TF;
 DownParam(URLInfo u, int i, TForm1 *p) { URL = u; D_Num = i; TF = p; }
};
//---------------------------------------------------------------------------

void __fastcall TForm1::WMCHANGECBCHAIN(TMessage &Message)
{
 if (hNextWnd == ((HWND) (Message.WParam))) {
    hNextWnd = (HWND) (Message.LParam);
 }
 Message.Result = ::SendMessage(hNextWnd, Message.Msg,
                Message.WParam, Message.LParam);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WMDRAWCLIPBOARD(TMessage &Message)
{
 ClipURL();
 Message.Result = ::SendMessage(hNextWnd, Message.Msg,
                Message.WParam, Message.LParam);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TRAYMENU(TMessage &Message)
{                                        //^XNgC̃ACRENbN
 if (Message.LParam == WM_RBUTTONDOWN) { //j[o
    POINT p;
    GetCursorPos(&p);
    SetForegroundWindow(Handle);
    PopupMenu1->Popup(p.x,p.y);
    PostMessage(Handle, WM_NULL, 0, 0);
 }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WMCLOSE(TMessage &Message)
{
 Hide();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IBCLOSE(TMessage &Message)
{                                  //Imagebordcloseꂽ烁
 PicCount[Message.WParam]--;       //EBhEʒuJ

 map<int, TImagebord*>::iterator pi;
 pi = map_imagebord.find(Message.LParam);
 delete pi->second;
 map_imagebord.erase(Message.LParam);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::DOWNERROR(TMessage &Message)
{                                  //_E[hs̏
 map<int, HANDLE>::iterator pt;
 pt = map_threadhandle.find(Message.WParam);
 CloseHandle(pt->second);
 map_threadhandle.erase(Message.WParam);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::MESSAGELOG(TMessage &Message)
{                                  //bZ[WXg{bNXɒǉ
 STATUSBOX->Items->Add(*(AnsiString *) Message.WParam);
 maxitem++;
 STATUSBOX->ItemIndex = 0;
 for (int itemindex = 0; itemindex <= maxitem; itemindex++) STATUSBOX->ItemIndex++;
 if(!Message.LParam) delete (AnsiString *) Message.WParam;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IBCREATE(TMessage &Message)
{                                  //Imagebordĕ\
 AnsiString tmpstr = tmpfilename + Message.LParam;

 pair<map<int, TImagebord*>::iterator, bool> pi;
 pi = map_imagebord.insert(make_pair(Message.LParam, (TImagebord*) NULL));

 try { Application->CreateForm(__classid(TImagebord), &pi.first->second); }
 catch (Exception &exception) { Application->ShowException(&exception); }

 ResetIcon();

 if (((DownParam *) Message.WParam)->URL.GetExtensions() == "bmp") {
    pi.first->second->Image1->Picture->RegisterFileFormat
       (__classid(TPicture), "", "Bitmap", __classid(Graphics::TBitmap));
 } else if (((DownParam *) Message.WParam)->URL.GetExtensions() == "png") {
    pi.first->second->Image1->Picture->RegisterFileFormat
       (__classid(TPicture), "", "PNG", __classid(TGLDPNG));
 } else if (((DownParam *) Message.WParam)->URL.GetExtensions() == "gif") {
    pi.first->second->Image1->Picture->RegisterFileFormat
       (__classid(TPicture), "", "GIF", __classid(TGIFImage));
 } else {
    pi.first->second->Image1->Picture->RegisterFileFormat
       (__classid(TPicture), "", "Jpeg", __classid(TJPEGImage));
 }
                                           //Ή摜`ύXŏ镔
 int count = INT_MAX, PicNum;
 for (int i = 0; i < 10; i++)
     if (count > PicCount[i]) {
        count = PicCount[i];
        PicNum = i;
     }
 PicCount[PicNum]++;

 pi.first->second->Left = (MaxX / 10) * PicNum;
 pi.first->second->Top = (MaxY / 10) * PicNum;

 pi.first->second->SetInfo(((DownParam *) Message.WParam)->URL, Handle, PicNum, Message.LParam);
 try { pi.first->second->Image1->Picture->LoadFromFile(tmpstr); }
 catch (...) {
    Beep();
    MessageDlg((((DownParam *) Message.WParam)->URL.GetExtensions() + "ł͂܂"), mtError,
                                     TMsgDlgButtons() << mbOK, 0);
    if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());
    PicCount[PicNum]--;
    delete ((DownParam *) Message.WParam);
    map<int, HANDLE>::iterator pt;
    pt = map_threadhandle.find(Message.LParam);
    CloseHandle(pt->second);
    map_threadhandle.erase(Message.LParam);
    return;
 }
 if (FileExists(tmpstr.c_str())) DeleteFile(tmpstr.c_str());

 int X = pi.first->second->Image1->Width;
 int Y = pi.first->second->Image1->Height;
 int d_Width = pi.first->second->Width - pi.first->second->ClientWidth;
 int d_Height = pi.first->second->Height - pi.first->second->ClientHeight;

 if ((X + d_Width > MaxX) && (Y + d_Height > MaxY)) {
    pi.first->second->Width = MaxX - 7;
    pi.first->second->Height = MaxY - 7;
 }
 if ((X + d_Width > MaxX) && (Y + d_Height < MaxY)) {
    pi.first->second->Width = MaxX - 7;
    if (Y + d_Height + SCROLLBARSIZE > MaxY) pi.first->second->Height = MaxY - 7;
    else pi.first->second->Height = Y + d_Height + SCROLLBARSIZE;
 }
 if ((X + d_Width < MaxX) && (Y + d_Height > MaxY)) {
    if (X + d_Width + SCROLLBARSIZE > MaxX) pi.first->second->Width = MaxX - 7;
    else pi.first->second->Width = X + d_Width + SCROLLBARSIZE;
    pi.first->second->Height = MaxY - 7;
 }
 if ((X + d_Width < MaxX) && (Y + d_Height < MaxY)) {
    pi.first->second->Width = X + d_Width;
    pi.first->second->Height = Y + d_Height;
 }

 pi.first->second->Image1->Left = 0;
 pi.first->second->Image1->Top = 0;
 pi.first->second->HorzScrollBar->Range = X;
 pi.first->second->VertScrollBar->Range = Y;
 pi.first->second->HorzScrollBar->Size = SCROLLBARSIZE;
 pi.first->second->VertScrollBar->Size = SCROLLBARSIZE;

 pi.first->second->Show();
 ForceForegroundWindow(Handle);

 delete ((DownParam *) Message.WParam);
 map<int, HANDLE>::iterator pt;
 pt = map_threadhandle.find(Message.LParam);
 CloseHandle(pt->second);
 map_threadhandle.erase(Message.LParam);
}
//---------------------------------------------------------------------------
#endif

