#ifndef URLINFO
#define URLINFO
#define USERAGENT "PopupViewer"
//---------------------------------------------------------------------------

class URLInfo {
      AnsiString URLtext, server, path, filename;
      unsigned short port;
 public:
      URLInfo(AnsiString URLString);
      URLInfo()  {
                   URLtext = server = path = filename = NULL;
                   port = 80;
                 }
      char *GetURLtext() { return URLtext.c_str(); }
      char *GetServer() {
              if (server == NULL) return NULL;
              else return server.c_str();
           }
      char *GetPath() {
              if (path == NULL) return NULL;
              else return path.c_str();
           }
      char *GetFilename() {
              if (filename == NULL) return NULL;
              else return filename.c_str();
           }
      AnsiString GetExtensions() {
              AnsiString tmp = filename;
              int i = tmp.LastDelimiter(".");
              tmp.Delete(1, i);
              tmp = tmp.LowerCase();
              return tmp;
           }
      AnsiString GetAnsiFilename() { return filename; }
      unsigned short GetPort() { return port; }
      AnsiString CreateGETRequest();
};
//---------------------------------------------------------------------------

URLInfo::URLInfo(AnsiString URLString) {
 AnsiString temp;                     //URLT[oA|[gApXƂ肾
 int len;
 server = path = filename = NULL;
 port = 80;

 URLString = URLString.Trim();

 URLtext = URLString;

 len = URLString.AnsiPos("://");
 if (len < 6 && len != 0) URLString.Delete(1, len + 2);
 len = URLString.AnsiPos("/");
 while (len == 1){
  URLString.Delete(1, 1);
  len = URLString.AnsiPos("/");
 }

 temp = URLString.SubString(1, len - 1);
 URLString.Delete(1, len - 1);
 path = URLString;
 URLString.Delete(1, 1);              //pX烋[gw
 if (path == "") { path = "/"; filename = "index.html"; }
 else if (URLString.Length() == URLString.AnsiPos("/")) filename = "index.html";
 else {
      for (len = 1; len != 0; len = URLString.AnsiPos("/"))
          URLString.Delete(1, len);
      filename = URLString;
 }

 len = temp.AnsiPos(":") - 1;
 if (len == -1) server = temp;
 else {
    URLString = temp.SubString(1, len);
    server = URLString;
    temp.Delete(1, len + 1);
    port = (unsigned short) temp.ToIntDef(80);
 }
}
//---------------------------------------------------------------------------

AnsiString URLInfo::CreateGETRequest() {  //GETNGXg
 AnsiString Request;
 Request = (
    "GET " + path + " HTTP/1.0\r\n" + "User-Agent: " + USERAGENT + "\r\n"
    + "Host: " + server + ":" + port + "\r\n"
    + "Referer: " + URLtext + "\r\n" + "Accept: */*" + "\r\n" + "\r\n"
 );

 return Request;
}
//---------------------------------------------------------------------------
#endif

