//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "image.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TImagebord *Imagebord;
//---------------------------------------------------------------------------
__fastcall TImagebord::TImagebord(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TImagebord::Save1Click(TObject *Sender)
{
 if (SaveDialog1->Execute()) {

    if (FileExists(SaveDialog1->FileName.c_str())) {
       Beep();
       if(MessageDlg("t@C㏑܂H", mtError,
          TMsgDlgButtons() << mbYes << mbNo, 0) == mrNo)
       return;
    }

    Image1->Picture->SaveToFile(SaveDialog1->FileName);

 }
}
//---------------------------------------------------------------------------

void __fastcall TImagebord::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if (Button == mbLeft) {
    Drag = true;
    MouseX = X;
    MouseY = Y;
 }
}
//---------------------------------------------------------------------------

void __fastcall TImagebord::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
 if (Drag) {
    int dX = - (X - MouseX);
    int dY = - (Y - MouseY);
    MouseX = X;
    MouseY = Y;

    if ((HorzScrollBar->Position + dX) < 0) HorzScrollBar->Position = 0;
    else if ((HorzScrollBar->Position + dX) > HorzScrollBar->Range)
            HorzScrollBar->Position = HorzScrollBar->Range;
    else {
       HorzScrollBar->Position += dX;
       MouseX += dX;
    }

    if ((VertScrollBar->Position + dY) < 0) VertScrollBar->Position = 0;
    else if ((VertScrollBar->Position + dY) > VertScrollBar->Range)
            VertScrollBar->Position = VertScrollBar->Range;
    else {
       VertScrollBar->Position += dY;
       MouseY += dY;
    }
 }
}
//---------------------------------------------------------------------------

void __fastcall TImagebord::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
 if (Button == mbLeft) Drag = false;
}
//---------------------------------------------------------------------------

void __fastcall TImagebord::FormCreate(TObject *Sender)
{
 Drag = false;
 DoubleBuffered = true;
}
//---------------------------------------------------------------------------

void __fastcall TImagebord::FormClose(TObject *Sender,
      TCloseAction &Action)
{
 SendMessageA(PahWnd, IB_CLOSE, WindowNum, DownNum);
}
//---------------------------------------------------------------------------


